#
# BEFORE UPDATING THIS PACKAGE, YOU _MUST_ DO THE FOLLOWING:
# - DO A LOCAL BUILD
# - INSTALL IT IN A TEST MACHINE
# - CHECK THAT 'display_help http://google.com' STILL WORK (INCLUDING CLOSING IT)
# - CHECK THAT MCC STILL RUNS
#
%define debug_package %{nil}
# *** ERROR: same build ID in nonidentical files!
#        /usr/bin/jsc-3
#   and  /usr/bin/jsc-1


%define oname		webkitgtk
%define lib3ver		3.0
%define major3		0
%define major2		25
%define lib3name	%mklibname webkitgtk %{lib3ver} %{major3}
%define devname3	%mklibname webkitgtk %{lib3ver} -d
%define inspector3name	webkit%{lib3ver}-webinspector
%define girname3	%mklibname %{name}-gir %{lib3ver}
%define girname2	%mklibname %{name}2-gir %{lib3ver}
%define girname2extension %mklibname %{name}2webextension-gir %{lib3ver}
%define libwebkit2      %mklibname webkit2gtk %{lib3ver} %{major2}
%define girjscore3	%mklibname jscore-gir %{lib3ver}
%define libjavascriptcoregtk3	%mklibname javascriptcoregtk %{lib3ver} %{major3}

%define pango	0
%if %{pango}
%define fontreq		pkgconfig(pango)
%define fontback	pango
%else
%define fontreq		pkgconfig(fontconfig) >= 1.0.0
%define fontback	freetype
%endif

Summary:	Web browser engine
Name:		webkit
Epoch:		1
Version:	2.4.5
Release:	1
License:	BSD and LGPLv2+
Group:		System/Libraries
Url:		http://www.webkitgtk.org
Source0:	http://www.webkitgtk.org/releases/%{oname}-%{version}.tar.xz
Patch0:         webkit-2.3.90-link.patch
# (blino) needed for first-time wizard (display_help) to be able to close its window with javascript
Patch2:         webkit-2.1.90-allowScriptsToCloseWindows.patch
Patch3:         webkitgtk-2.1.92-gtk-includes.patch

BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gperf
BuildRequires:	gtk-doc
BuildRequires:	libtool
BuildRequires:	%{fontreq}
BuildRequires:	icu-devel >= 49
BuildRequires:	jpeg-devel
BuildRequires:	libstdc++-devel
BuildRequires:	automake
BuildRequires:	pkgconfig(enchant)
BuildRequires:	pkgconfig(gail)
BuildRequires:	pkgconfig(gail-3.0)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(geoclue)
BuildRequires:	pkgconfig(gnome-keyring-1)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(gstreamer-plugins-base-1.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(gtk+-3.0)
BuildRequires:	pkgconfig(libcurl) >= 7.11.0
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(librsvg-2.0) >= 2.2.0
BuildRequires:	pkgconfig(libsoup-2.4) >= 2.29.90
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(xft)
BuildRequires:	pkgconfig(xt)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(libsecret-1)
BuildRequires:	chrpath

%description
WebKit is an open source web browser engine.

#----------------------------------------------------------------------------

%package -n %{name}%{lib3ver}
Summary:	GTK+3 port of WebKit web browser engine - shared files
Group:		Development/GNOME and GTK+
Requires:	%{lib3name} = %{EVRD}
Conflicts:	%{lib3name} < 1:1.4.1-5
Conflicts:	%{name} < 1:1.4.1-6
%rename %{name}3

%description -n %{name}%{lib3ver}
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}%{lib3ver}

%files -n %{name}%{lib3ver} -f WebKitGTK-3.0.lang
%dir %{_datadir}/webkitgtk-3.0
%{_datadir}/webkitgtk-3.0/images
%{_datadir}/webkitgtk-3.0/resources

#----------------------------------------------------------------------------

%package -n %{lib3name}
Summary:	GTK+3 port of WebKit web browser engine
Group:		System/Libraries
Obsoletes:	%{inspector3name}

%description -n %{lib3name}
The GTK+3 port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%files -n %{lib3name}
%{_libdir}/lib%{name}gtk-%{lib3ver}.so.%{major3}*

#----------------------------------------------------------------------------

%package -n %{libjavascriptcoregtk3}
Summary:	GTK+3 port of WebKit web browser engine
Group:		System/Libraries
Obsoletes:	%{_lib}javascriptcoregtk3.0 < %{EVRD}

%description -n %{libjavascriptcoregtk3}
The GTK+3 port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%files -n %{libjavascriptcoregtk3}
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so.%{major3}*

#----------------------------------------------------------------------------

%package -n %{devname3}
Summary:	Development files for WebKit GTK+3 port
Group:		Development/GNOME and GTK+
Provides:	webkitgtk3-devel = %{EVRD}
Provides:	libwebkitgtk3-devel = %{EVRD}
Requires:	%{lib3name} = %{EVRD}
Requires:	%{libwebkit2} = %{EVRD}
Requires:	%{libjavascriptcoregtk3} = %{EVRD}
Requires:	%{girjscore3} = %{EVRD}
Requires:	%{girname3} = %{EVRD}
Requires:	%{girname2} = %{EVRD}
Requires:       %{girname2extension} = %{EVRD}

%description -n %{devname3}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux. This package contains development headers.

%files -n %{devname3}
%{_libdir}/lib%{name}gtk-%{lib3ver}.so
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so
%{_libdir}/libwebkit2gtk-%{lib3ver}.so
%{_includedir}/%{name}gtk-%{lib3ver}
%{_libdir}/pkgconfig/%{name}gtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/javascriptcoregtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/%{name}2gtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/%{name}2gtk-web-extension-%{lib3ver}.pc
%{_datadir}/gir-1.0/JavaScriptCore-%{lib3ver}.gir
%{_datadir}/gir-1.0/WebKit-%{lib3ver}.gir
%{_datadir}/gir-1.0/WebKit2-%{lib3ver}.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-%{lib3ver}.gir
%{_datadir}/gtk-doc/html/webkitgtk3/*
%{_datadir}/gtk-doc/html/webkit2gtk/*
%{_datadir}/gtk-doc/html/webkitdomgtk/*

#----------------------------------------------------------------------------

%package -n webkit3-gtklauncher
Summary:	WebKit GTK+3 example application
Group:		Development/GNOME and GTK+

%description -n webkit3-gtklauncher
GtkLauncher is an example application for WebKit GTK+3.

%files -n webkit3-gtklauncher
%{_libdir}/%{name}3/GtkLauncher

#----------------------------------------------------------------------------

%package -n webkit3-jsc
Summary:	JavaScriptCore shell for WebKit GTK+3
Group:		Development/GNOME and GTK+

%description -n webkit3-jsc
jsc is a shell for JavaScriptCore, WebKit's JavaScript engine. It
allows you to interact with the JavaScript engine directly.

%files -n webkit3-jsc
%{_bindir}/jsc-3

#----------------------------------------------------------------------------

%package -n %{girjscore3}
Summary:	GObject Introspection interface description for JSCore
Group:		System/Libraries
Conflicts:	%{libjavascriptcoregtk3} < %{epoch}:1.5.2-2

%description -n %{girjscore3}
GObject Introspection interface description for JSCore.

%files -n %{girjscore3}
%{_libdir}/girepository-1.0/JavaScriptCore-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{girname3}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Conflicts:	%{lib3name} < %{epoch}:1.5.2-2

%description -n %{girname3}
GObject Introspection interface description for WebKit.

%files -n %{girname3}
%{_libdir}/girepository-1.0/WebKit-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{girname2}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries
Requires:       %{libwebkit2} = %{EVRD}

%description -n %{girname2}
GObject Introspection interface description for WebKit2.

%files -n %{girname2}
%{_libdir}/girepository-1.0/WebKit2-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{girname2extension}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries
Obsoletes:      %{_lib}webkit2webextension3.0 < 1:2.4.1-2

%description -n %{girname2extension}
GObject Introspection interface description for WebKit2.

%files -n %{girname2extension}
%{_libdir}/girepository-1.0/WebKit2WebExtension-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{libwebkit2}
Summary:        GTK+3 port of WebKit2 web browser engine
Group:          System/Libraries
Requires:       %{name}3.0 = %{EVRD}
Requires:       %{name}2gtk = %{EVRD}
Provides:       libwebkit2gtk3 = %{version}-%{release}

%description -n %{libwebkit2}
The GTK+3 port of WebKit2 is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%files -n %{libwebkit2}
%{_libdir}/lib%{name}2gtk-%{lib3ver}.so.%{major2}
%{_libdir}/lib%{name}2gtk-%{lib3ver}.so.%{major2}.*

#----------------------------------------------------------------------------

%package -n %{name}2gtk
Summary:        GTK+3 port of WebKit2 web browser engine - shared files
Group:          System/Libraries

%description -n %{name}2gtk
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}2gtk%{lib3ver}.

%files -n %{name}2gtk
%dir %{_libdir}/webkit2gtk-%{lib3ver}
%dir %{_libdir}/webkit2gtk-%{lib3ver}/injected-bundle
%{_libdir}/webkit2gtk-%{lib3ver}/injected-bundle/libwebkit2gtkinjectedbundle.so
%{_libexecdir}/WebKitNetworkProcess
%{_libexecdir}/WebKitPluginProcess
%{_libexecdir}/WebKitWebProcess

#----------------------------------------------------------------------------

%prep
%setup -qn %{oname}-%{version}
%apply_patches
# Don't force -O2
sed -i 's/-O2//g' configure.ac

%build
# Use linker flags to reduce memory consumption on low-mem architectures
%ifarch %{arm}
%define lowmemflags -Wl,--no-keep-memory -Wl,--reduce-memory-overheads
export CFLAGS="`echo %{optflags} %lowmemflags | sed -e 's/-gdwarf-4//' -e 's/-fvar-tracking-assignments//' -e 's/-frecord-gcc-switches//'`"
mkdir -p bfd
ln -s %{_bindir}/ld.bfd bfd/ld
export PATH=$PWD/bfd:$PATH
export CC="%{__cc} -fuse-ld=bfd"
export CXX="%{__cxx} -fuse-ld=bfd"
%global ldflags %{ldflags} -fuse-ld=bfd
%else
export CFLAGS="`echo %{optflags} | sed -e 's/-gdwarf-4//' -e 's/-fvar-tracking-assignments//' -e 's/-frecord-gcc-switches//'`"
%endif

export CXXFLAGS="$CFLAGS"

%configure2_5x \
	--enable-dependency-tracking \
	--with-gtk=3.0 \
	--enable-webkit2 \
	--enable-jit \
	--enable-video \
	--enable-introspection

make V=1 -j4

%install
%makeinstall_std

mkdir -p %{buildroot}%{_libdir}/%{name}3
install -m 755 Programs/GtkLauncher %{buildroot}%{_libdir}/%{name}3

# only useful for testing, should not be installed system-wide.
# reported upstream as 22812 - AdamW 2008/12
rm -rf %{buildroot}%{_libdir}/libtestnetscapeplugin.*

# Remove lib64 rpaths
chrpath --delete %{buildroot}%{_bindir}/jsc-3
chrpath --delete %{buildroot}%{_libdir}/libwebkitgtk-3.0.so
chrpath --delete %{buildroot}%{_libexecdir}/%{name}3/GtkLauncher

# Rename to avoid file conflicts with webkitgtk2
mv %{buildroot}%{_datadir}/gtk-doc/html/webkitgtk %{buildroot}%{_datadir}/gtk-doc/html/webkitgtk3

%find_lang WebKitGTK-3.0


%changelog
* Mon Sep 01 2014 Tigro <ashejn@gmail.com> 1:2.4.5-1
+ Revision: 9cf77cc
- update to 2.4.5

* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1:2.4.3-4
+ Revision: 9b58f5a
- MassBuild#440: Increase release tag

* Wed Jun 18 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.4.3-3
+ Revision: 2ad9317
- Bump release to rebuild against new icu

* Tue Jun 03 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.4.3-2
+ Revision: 1b8ca39
- MassBuild#430: Increase release tag

* Wed May 28 2014 Tigro <ashejn@gmail.com> 1:2.4.3-1
+ Revision: 337e6eb
- update to 2.4.3

* Wed May 14 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: 59e6ba4
- pack some files

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: ab23728
- added BR: automake

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: 4504190
- fix name

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: a522f04
- build with webkit2

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: 8cae470
- added patches

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.2-1
+ Revision: 9fecf9c
- update to 2.4.2

* Tue May 13 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: e072c8c
- Revert "Revert "enable webkit2""
- This reverts commit 9f21a5fa818ac16fa0f7c9c08e01836ba1602e20.

* Wed May 07 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: 9f21a5f
- Revert "enable webkit2"
- This reverts commit 5c1d6db1babf367fbd95c571f7c1ced4d66091a5.

* Wed May 07 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: 5c1d6db
- enable webkit2

* Tue Apr 22 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: d3ca91f
- pack some files and remove webinspector package

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: 7c788f1
- drop patch

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: 5a36388
- drop patch

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: ce53657
- drop patch

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: 4ef5b7e
- drop patch

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: e50be3a
- drop link patch

* Mon Apr 21 2014 Tigro <ashejn@gmail.com> 1:2.4.0-1
+ Revision: b3ee028
- update to 2.4.0

* Fri Jan 17 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.0.4-3
+ Revision: 9b87865
- LOG Drop subpackages moved to webkitgtk2

* Wed Oct 16 2013 Tigro <ashejn@gmail.com> 1:2.0.4-2
+ Revision: ffbcc22
- remove some lib64 rpaths and drop changelog

* Wed Sep 11 2013 akdengi <kazancas@mandriva.ru> 1:2.0.4-1
+ Revision: 7cf4e37
- sync with Cooker to 2.0.4

* Tue Sep 10 2013 Alexander Kazancev <kazancas@gmail.com> 1:2.0.3-2
+ Revision: d9628e7
- Rebuild with harfbuzz error

* Thu Jun 20 2013 root <root@localhost.localdomain> 1:2.0.3-1
+ Revision: a36bb05
- sync to gnome38 branch

* Thu Nov 01 2012 Dmitry Mikhirev <mikhirev@mezon.ru> 1:1.10.0-4
+ Revision: d7b465b
- add missing source to file-store

* Tue Oct 16 2012 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:1.10.0-4
+ Revision: 3fbcfbd
- LOG Properly update to 1.10.0 from older spec

* Mon Oct 15 2012 Arkady L. Shane <arkady.shane@rosalab.ru> 1:1.10.0-3
+ Revision: a8fdb6a
- another -g1 fix

* Mon Oct 15 2012 Arkady L. Shane <arkady.shane@rosalab.ru> 1:1.10.0-3
+ Revision: 10153b3
- use -g1


